%define anolis_release 3
%define debug_package %{nil}

Name:		kpatch-build
Version:	1.0.0
Release:	%{anolis_release}%{?dist}
Summary:	kpatch - live kernel patching
License:	GPLv2 
URL:		https://gitee.com/anolis/kpatch-build
Source0:	https://gitee.com/anolis/kpatch-build/archive/refs/tags/%{name}-v%{version}.tar.gz

BuildRequires:	kernel-devel make gcc patch 
BuildRequires:  bison flex openssl-devel elfutils elfutils-devel dwarves

Requires: 	bison flex openssl-devel elfutils elfutils-devel dwarves
Requires:       kernel-devel gcc patch make

Patch1001:	1001-change-the-install-dir-to-system-path.patch
Patch1002:	1002-add-loongarch64-support-for-kpatch-build.patch
Patch1003:	1003-add-riscv64-support-for-kpatch-build.patch

%description
kpatch-build is a hot patch creation tool that can perform CVE and 
Bug fixes on the operating system kernel without restarting the 
system and interrupting business.

%package doc
Summary:        Documentation files for %{name}
Requires:       %{name} = %{version}-%{release}
BuildArch:      noarch

%description    doc
The %{name}-doc package contains documentation files for %{name}.

%prep
%autosetup -n %{name}-v%{version} -p1

%build
cd kpatch-build
make BUILDMOD=no

%install
pushd kpatch-build
%make_install
popd

install -d %{buildroot}/%{_datadir}/kpatch/patch
install -m 644 kmod/patch/*  %{buildroot}/%{_datadir}/kpatch/patch

%files
%license COPYING
%{_bindir}/kpatch-build
%dir %{_libexecdir}/kpatch
%{_libexecdir}/kpatch/create-diff-object
%{_libexecdir}/kpatch/create-klp-module
%{_libexecdir}/kpatch/create-kpatch-module
%{_libexecdir}/kpatch/kpatch-cc
%dir %{_datadir}/kpatch/patch
%{_datadir}/kpatch/patch/*

%files doc
%doc README.md README.en.md
%doc doc/INSTALL.md doc/patch-author-guide.md
%doc doc/arm64-upstream-prerequisites.md

%changelog
* Tue Jun 17 2025 Anmeng Zhang <zhang.anmeng@zte.com.cn> - 1.0.0-3
- add riscv64 support for kpatch build

* Wed Oct 18 2023 Wenlong Zhang <zhangwenlong@loongson.cn>  - 1.0.0-2
- add loong64 support for kpatch-build

* Tue Jun 20 2022 happy_orange <songnannan@linux.alibaba.com> - 1.0.0-1
- package init.
